---
apiVersion: v1
kind: Service
metadata:
  name: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
  namespace: {{ .Release.Namespace }}
  labels:
    app: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
    chart: {{ template "taranta.chart" . }}
    release: {{ .Release.Name }}
    heritage: {{ .Release.Service }}
spec:
  type: ClusterIP
  ports:
  - name: tangogql-tcp
    port: 5004
    targetPort: tangogql-tcp
    protocol: TCP
  selector:
    app: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}

---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
  namespace: {{ .Release.Namespace }}
  labels:
    app: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
    chart: {{ template "taranta.chart" . }}
    release: {{ .Release.Name }}
    heritage: {{ .Release.Service }}
spec:
  selector:
    matchLabels:
      app: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
  serviceName: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
  replicas: {{ .Values.tangogql.replicas }}
  template:
    metadata:
      labels:
        app: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
        chart: {{ template "taranta.chart" . }}
        release: {{ .Release.Name }}
        heritage: {{ .Release.Service }}
    spec:
      initContainers:
      - name: waitdatabaseds
        image: artefact.skao.int/ska-tango-images-tango-itango:9.3.6
        imagePullPolicy: IfNotPresent
        command:
          - /usr/local/bin/wait-for-it.sh
          - {{ .Values.global.tango_host}}
          - --timeout=30
          - --strict
          - --
          - echo "Databaseds ready for use."
      containers:
      - name: tangogql
        image: "{{ .Values.tangogql.image.registry }}/{{ .Values.tangogql.image.image }}:{{ .Values.tangogql.image.tag }}"
        imagePullPolicy: {{ .Values.tangogql.image.pullPolicy }}
        volumeMounts:
        - mountPath: /var/log/tangogql
          name: tangogql-logs
        - name: logging-config
          mountPath: /app/logging.yaml
          subPath: logging.yaml
        env:
          - name: LOG_PATH
            value: "/var/log/tangogql"
          - name: PYTHONUNBUFFERED
            value: "1"
          - name: TANGO_HOST
            value: {{ .Values.global.tango_host}}
        ports:
        - name: tangogql-tcp
          containerPort: 5004
          protocol: TCP
        resources:
{{ toYaml .Values.tangogql.resources | indent 10 }}

      volumes:
      - name: logging-config
        configMap:
          name: tangogql-config-{{ template "taranta.name" . }}-{{ .Release.Name }}
      - name: tangogql-logs
        persistentVolumeClaim:
          claimName: tangogql-{{ template "taranta.name" . }}-{{ .Release.Name }}
{{- with .Values.nodeSelector }}
      nodeSelector:
{{ toYaml . | indent 8 }}
{{- end }}
{{- with .Values.affinity }}
      affinity:
{{ toYaml . | indent 8 }}
{{- end }}
{{- with .Values.tolerations }}
      tolerations:
{{ toYaml . | indent 8 }}
{{- end }}
